
#include <usbdrv.h>
#include <pt.h>
#define PT_DELAY(pt,ms,tsVar) \
  tsVar = millis(); \
  PT_WAIT_UNTIL(pt, millis()-tsVar >= (ms));

#define LEFT_BUTTON PIN_PC0
#define DOWN_BUTTON PIN_PC1
#define RIGHT_BUTTON PIN_PC4
#define UP_BUTTON PIN_PC5




#define RQ_BUTTONS_STATUS 0
struct pt ptButtonsTask;
int BUTTONS[] = { UP_BUTTON, DOWN_BUTTON, LEFT_BUTTON, RIGHT_BUTTON, UP_BUTTON2, DOWN_BUTTON2, LEFT_BUTTON2, RIGHT_BUTTON2  };
int buttons_state = 0;
//////////////////////////////////////////////////////////////////////
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
  usbRequest_t *rq = (usbRequest_t*)data;
  
  static uint8_t i;
  if (rq->bRequest == RQ_BUTTONS_STATUS)
  {
    /* point usbMsgPtr to the data to be returned to host */
    usbMsgPtr = (uint8_t*) &buttons_state;

    /* return the number of bytes of data to be returned to host */
    return sizeof(buttons_state);
  }

  return 0;   /* nothing to do; return no data back to host */
}
,
PT_THREAD(buttonsTask(struct pt *pt)){
  static uint32_t ts;
  static uint8_t i;
  PT_BEGIN(pt);
  while(1){
    buttons_state = 0;
    for(i = 0; i < 4; i++){
      buttons_state |= (!digitalRead(BUTTONS[i])) << i;
      PT_DELAY(pt, 20, ts);
    }
    PT_DELAY(pt, 100, ts);
  }
  PT_END(pt);
}
//////////////////////////////////////////////////////////////////////
void setup()
{
  
    
    pinMode(RIGHT_BUTTON, INPUT_PULLUP);
    pinMode(LEFT_BUTTON, INPUT_PULLUP);
    pinMode(UP_BUTTON, INPUT_PULLUP);
    pinMode(DOWN_BUTTON, INPUT_PULLUP);

  
    usbInit();

    /* enforce re-enumeration of USB devices */
    usbDeviceDisconnect();
    delay(300);
    usbDeviceConnect();

    PT_INIT(&ptButtonsTask);
    
}

//////////////////////////////////////////////////////////////////////
void loop()
{
  usbPoll();
  buttonsTask(&ptButtonsTask);
}
