#! - * - coding: utf-8 - * -
import kivy
kivy.require('1.9.0')
from kivy.uix.widget import Widget
from kivy.app import App
from kivy.uix.floatlayout import FloatLayout
from kivy.uix.gridlayout import GridLayout
from kivy.uix.image import Image
from kivy.lang import Builder
from kivy.animation import Animation, AnimationTransition
from kivy.properties import NumericProperty, ReferenceListProperty,\
    ObjectProperty, ListProperty, BooleanProperty, StringProperty
from kivy.clock import Clock
from kivy.vector import Vector
from kivy.core.window import Window
from random import randint
from kivy.core.audio import SoundLoader
from kivy.uix.screenmanager import ScreenManager, Screen, FadeTransition
from kivy.uix.label import Label
import sys
from kivy.config import Config
import time
import usbConfig



class GameController(Widget):
    score = NumericProperty(0)
    player = ObjectProperty(None)
    player2 = ObjectProperty(None)
    ball = ObjectProperty(None)
    counttime = NumericProperty(120*60)
    goal = ObjectProperty(None)
    goal2 = ObjectProperty(None)
    score_label_text = StringProperty("")

    pressed_keys = {
            'up': False,
            'left': False,
            'right': False,
            'down': False,
            'w': False,
            's': False,
            'a': False,
            'd': False,
    }
    def __init__(self, **kwargs):
        super(GameController, self).__init__(**kwargs)
        self._keyboard = Window.request_keyboard(self._keyboard_closed, self)
        self._keyboard.bind(on_key_down = self._on_keyboard_down)
        self._keyboard.bind(on_key_up = self._on_keyboard_up)
        self.setup_first_time = False
        
        # score_label

        # Builder.load_file("labels/game_controller.kv")


    def setup(self):
        self.ball.pos = [300,500]
        self.ball_velocity_x = 0
        self.ball_velocity_y = 0
        self.player.x = 500
        self.player2.x = 300
        self.buttons = [False, False, False, False]
        self.buttons2 = [False, False, False, False]
    

    def _keyboard_closed (self):
        self._keyboard.unbind(on_key_down=self._on_keyboard_down)
        self._keyboard = None

    def _on_keyboard_down (self, keyboard, keycode, text, modifiers):
        pressed_key = keycode[1]
        # USB - Generic Activated for player 1
        if pressed_key in "wasd" and usbConfig.usb_status[0] and False:
            return True
        if pressed_key in ['up', 'down', 'left', 'right'] and usbConfig.usb_status[1] and False:  
            return True

        # Play with keyboard
        self.pressed_keys[pressed_key] = True
        return True

    def _on_keyboard_up (self, keyboard, keycode):
        released_key = keycode[1]
        self.pressed_keys[released_key] = False
        return True

    def practicum_control(self):
        pressed_keys = self.pressed_keys
        buttons = self.buttons
        if usbConfig.usb_status[0] == True:
            try:
                buttons = usbConfig.read_usb(usbConfig.usb_list[0])
            except:
                pass
            pressed_keys['w'] = buttons[2]
            pressed_keys['s'] = buttons[3]
            pressed_keys['a'] = buttons[1]
            pressed_keys['d'] = buttons[0]
        if usbConfig.usb_status[1]:
            buttons2 = usbConfig.read_usb(usbConfig.usb_list[1])
            pressed_keys['up'] = buttons2[0]
            pressed_keys['down'] = buttons2[1]
            pressed_keys['left'] = buttons2[2]
            pressed_keys['right'] = buttons2[3]
        

    def keyboard_control(self):
        pressed_keys = self.pressed_keys
        if pressed_keys['up']:
            self.player.jump()
        if pressed_keys['left']:
            self.player.move()
        if pressed_keys['right']:
            self.player.move(reverse=True)
        if pressed_keys['a']:
            self.player2.move()
        if pressed_keys['d']:
            self.player2.move(reverse=True)
        if pressed_keys['w']:
            self.player2.jump()

    def update(self, dt):
        if not self.setup_first_time:
            self.setup()
            time.sleep(1)
            self.setup()
            self.setup_first_time = True
        self.players = [self.player, self.player2]
        self.practicum_control()
        self.count_time()
        self.keyboard_control()
        self.player.update()
        self.player2.update()
        self.ball.update()
        self.goal.update()
        self.goal2.update()
        self.score_label_text = "[color=ff0000]Player 1 Score: %d[/color] || [color=0000ff]Player 2 Score: %d [/color]" % (self.goal.score, self.goal2.score)

    def count_time(self):
        if (self.counttime > 0):
            self.counttime -= 1
    	if (self.counttime < 600):
            pass
    	    # self.countdown.play()
    	if (self.counttime == 1):
    	    # self.countdown.stop()
            # Change screen when time's up :D
    	    self.parent.parent.current = "end"
    	if (self.counttime == 0):
            pass
