# - * - coding: utf-8 - * -

import kivy
kivy.require('1.9.0')
from kivy.uix.widget import Widget
from kivy.app import App
from kivy.uix.floatlayout import FloatLayout
from kivy.uix.gridlayout import GridLayout
from kivy.uix.image import Image
from kivy.lang import Builder
from kivy.animation import Animation, AnimationTransition
from kivy.properties import NumericProperty, ReferenceListProperty,\
    ObjectProperty, ListProperty, BooleanProperty
from kivy.clock import Clock
from kivy.vector import Vector
from kivy.core.window import Window
from random import randint
from kivy.core.audio import SoundLoader
from kivy.uix.screenmanager import ScreenManager, Screen, FadeTransition
import sys
from kivy.config import Config

class Ball(Widget):
    velocity_x = NumericProperty()
    velocity_y = NumericProperty(10.0)
    acceleration_x = NumericProperty(0.001)
    acceleration_y = NumericProperty(-0.2)
    landed = NumericProperty(0)
    mass = NumericProperty(1.0)
    color = ListProperty([255,255,255,255])
    def update(self):
        self.move()
        self.collision_player()

    def move(self, reverse=False):
        self.velocity_x *= 0.99 # energy lost
        self.velocity_y *= 0.99
        self.velocity_x += self.acceleration_x
        try:
            self.acceleration = self.acceleration_x * (self.velocity_x / abs(self.velocity_x))
        except:
            pass
        self.velocity_y += self.acceleration_y
        self.x += self.velocity_x
        self.y += self.velocity_y
        if self.x < 0:
            self.x = 0
            self.velocity_x *= -0.2
            self.acceleration_x *= -1.0
        if self.x > self.parent.width - self.width:
            self.x = self.parent.width - self.width;
            self.velocity_x *= -0.2
            self.acceleration_x *= -1.0
        if self.y > self.parent.height:
            self.y = self.parent.height
            self.velocity_y *= -0.6
        if self.y < self.landed + self.height:
            self.y = self.landed + self.height
            self.velocity_y *= -0.6

    def collision_player(self):
        for player in self.parent.players:
            if self.collide_widget(player):
                if abs(player.velocity_x) > 1.0:
                    player_direction = (abs(player.velocity_x) / player.velocity_x)
                    self.acceleration = player_direction * abs(self.acceleration_x)
                    self.velocity_x = player_direction * abs(player.velocity_x * 0.5) \
                            + (player_direction * abs(self.velocity_x) * 0.5)
                    self.velocity_x *= -1.0
                else:
                    self.acceleration_x *= -1.0
                    self.velocity_x = -self.velocity_x
                self.velocity_y += abs(player.velocity_x) * 0.3
        self.move()

	
